package de.cliffbreak.varo.uitls;

import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageDecoder;
import net.minecraft.server.v1_15_R1.Packet;

import java.lang.reflect.Field;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.craftbukkit.v1_15_R1.entity.CraftPlayer;
import org.bukkit.entity.Player;

public class PacketReader {

    Player player;
    Channel channel;

    public PacketReader(final Player player) {
        this.player = player;
    }

    public void inject() {
        final CraftPlayer cPlayer = (CraftPlayer) this.player;
        channel = cPlayer.getHandle().playerConnection.networkManager.channel;
        channel.pipeline().addAfter("decoder", "PacketInjector", new MessageToMessageDecoder<Packet<?>>() {
            @Override
            protected void decode(final ChannelHandlerContext arg0, final Packet<?> packet, final List<Object> arg2)
                    throws Exception {
                arg2.add(packet);
                readPacket(packet);
            }
        });
    }

    public void uninject() {
        if (channel.pipeline().get("PacketInjector") != null) {
            channel.pipeline().remove("PacketInjector");
        }
    }

    public void readPacket(final Packet<?> packet) {
        if (packet.getClass().getSimpleName().equalsIgnoreCase("PacketPlayInUseEntity")) {
            final int id = (Integer) getValue(packet, "a");

            System.out.println(getValue(packet, "action").toString());
            System.out.println(getValue(packet, "a").toString());

            // if (Main.npc.getEntityID() == id) {
            // if (getValue(packet, "action").toString().equalsIgnoreCase("ATTACK")) {
            // Main.npc.animation(1);
            // } else if (getValue(packet, "action").toString().equalsIgnoreCase("INTERACT")) {

            // }
            // }
        }
    }

    public void setValue(final Object obj, final String name, final Object value) {
        try {
            final Field field = obj.getClass().getDeclaredField(name);
            field.setAccessible(true);
            field.set(obj, value);
        } catch (final Exception e) {
        }
    }

    public Object getValue(final Object obj, final String name) {
        try {
            final Field field = obj.getClass().getDeclaredField(name);
            field.setAccessible(true);
            return field.get(obj);
        } catch (final Exception e) {
        }
        return null;
    }

}